Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 407)
+++ palm/trunk/SOURCE/Makefile	(revision 410)
@@ -5,4 +5,8 @@
 # -----------------
 # +set_particle_attributes, set_slicer_attributes_dvrp
+#
+# Branch revisions:
+# -----------------
+# +data_output_mask, init_masks, user_data_output_mask
 #
 # Former revisions:
@@ -55,14 +59,15 @@
 	close_file.f90 compute_vpt.f90 coriolis.f90 cpu_log.f90 \
 	cpu_statistics.f90 data_log.f90 data_output_dvrp.f90 \
-	data_output_profiles.f90 data_output_ptseries.f90 \
+	data_output_mask.f90 data_output_profiles.f90 data_output_ptseries.f90 \
 	data_output_spectra.f90 data_output_tseries.f90 data_output_2d.f90 \
 	data_output_3d.f90 diffusion_e.f90 diffusion_s.f90 diffusion_u.f90 \
 	diffusion_v.f90 diffusion_w.f90 diffusivities.f90 disturb_field.f90 \
-	disturb_heatflux.f90 eqn_state_seawater.f90 exchange_horiz.f90 exchange_horiz_2d.f90 \
+	disturb_heatflux.f90 eqn_state_seawater.f90 exchange_horiz.f90 \
+	exchange_horiz_2d.f90 \
 	fft_xy.f90 flow_statistics.f90 global_min_max.f90 \
 	header.f90 impact_of_latent_heat.f90 inflow_turbulence.f90 \
 	init_1d_model.f90 init_3d_model.f90 init_advec.f90 \
 	init_cloud_physics.f90 init_coupling.f90 init_dvrp.f90 init_grid.f90 \
-	init_ocean.f90 init_particles.f90 init_pegrid.f90 \
+	init_masks.f90 init_ocean.f90 init_particles.f90 init_pegrid.f90 \
 	init_pt_anomaly.f90 init_rankine.f90 init_slope.f90 \
 	interaction_droplets_ptq.f90 local_flush.f90 local_getenv.f90 \
@@ -83,5 +88,5 @@
 	user_check_data_output.f90 user_check_data_output_pr.f90 \
 	user_check_parameters.f90 user_data_output_2d.f90 \
-	user_data_output_3d.f90 user_data_output_dvrp.f90 \
+	user_data_output_3d.f90 user_data_output_dvrp.f90 user_data_output_mask.f90 \
 	user_define_netcdf_grid.f90 user_dvrp_coltab.f90 user_header.f90 \
 	user_init.f90 user_init_3d_model.f90 user_init_grid.f90 \
@@ -100,5 +105,6 @@
 	check_for_restart.o check_open.o check_parameters.o close_file.o \
 	compute_vpt.o coriolis.o cpu_log.o cpu_statistics.o data_log.o \
-	data_output_dvrp.o data_output_profiles.o data_output_ptseries.o \
+	data_output_dvrp.o data_output_mask.o data_output_profiles.o \
+	data_output_ptseries.o \
 	data_output_spectra.o data_output_tseries.o data_output_2d.o \
 	data_output_3d.o diffusion_e.o diffusion_s.o diffusion_u.o \
@@ -107,5 +113,5 @@
 	flow_statistics.o global_min_max.o header.o impact_of_latent_heat.o \
 	inflow_turbulence.o init_1d_model.o init_3d_model.o init_advec.o init_cloud_physics.o \
-	init_coupling.o init_dvrp.o init_grid.o init_ocean.o init_particles.o init_pegrid.o \
+	init_coupling.o init_dvrp.o init_grid.o init_masks.o init_ocean.o init_particles.o init_pegrid.o \
 	init_pt_anomaly.o init_rankine.o init_slope.o \
 	interaction_droplets_ptq.o local_flush.o local_getenv.o local_stop.o \
@@ -124,5 +130,5 @@
 	user_advec_particles.o user_check_data_output.o \
 	user_check_data_output_pr.o user_check_parameters.o \
-	user_data_output_2d.o user_data_output_3d.o user_data_output_dvrp.o \
+	user_data_output_2d.o user_data_output_3d.o user_data_output_mask.o user_data_output_dvrp.o \
 	user_define_netcdf_grid.o user_dvrp_coltab.o user_header.o \
 	user_init.o user_init_3d_model.o user_init_grid.o \
@@ -190,4 +196,5 @@
 data_log.o: modules.o
 data_output_dvrp.o: modules.o
+data_output_mask.o: modules.o
 data_output_profiles.o: modules.o
 data_output_ptseries.o: modules.o
@@ -220,4 +227,5 @@
 init_dvrp.o: modules.o
 init_grid.o: modules.o
+init_masks.o: modules.o
 init_ocean.o: modules.o eqn_state_seawater.o
 init_particles.o: modules.o random_function.o
@@ -282,4 +290,5 @@
 user_data_output_2d.o: modules.o user_module.o
 user_data_output_3d.o: modules.o user_module.o
+user_data_output_mask.o: modules.o user_module.o
 user_data_output_dvrp.o: modules.o user_module.o
 user_define_netcdf_grid.o: modules.o user_module.o
Index: palm/trunk/SOURCE/check_open.f90
===================================================================
--- palm/trunk/SOURCE/check_open.f90	(revision 407)
+++ palm/trunk/SOURCE/check_open.f90	(revision 410)
@@ -5,4 +5,8 @@
 ! -----------------
 ! 
+!
+! Branch revisions:
+! -----------------
+! masked data output
 !
 ! Former revisions:
@@ -60,5 +64,5 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=2)   ::  suffix
+    CHARACTER (LEN=2)   ::  mask_char, suffix
     CHARACTER (LEN=20)  ::  xtext = 'time in s'
     CHARACTER (LEN=30)  ::  filename
@@ -123,11 +127,15 @@
 
        CASE ( 15, 16, 17, 18, 19, 40:49, 50:59, 81:84, 101:107, 109, 111:113, &
-              116 )
+              116, 121:160 )
+	      
+	  IF ( .NOT. format_parallel_io) THEN
           
-          IF ( myid /= 0 )  THEN
-             WRITE( message_string, * ) 'opening file-id ',file_id, &
-                                        ' not allowed for PE ',myid
-             CALL message( 'check_open', 'PA0167', 2, 2, -1, 6, 1 )
-          ENDIF
+             IF ( myid /= 0 )  THEN
+                WRITE( message_string, * ) 'opening file-id ',file_id, &
+                                           ' not allowed for PE ',myid
+                CALL message( 'check_open', 'PA0167', 2, 2, -1, 6, 1 )
+             ENDIF
+	     
+	  ENDIF
 
        CASE ( 21, 22, 23 )
@@ -1233,7 +1241,117 @@
 
           ENDIF
+
+       CASE ( 121:160 )
+!
+!--       Set filename depending on unit number
+          IF ( file_id <= 140 )  THEN
+             mid = file_id - 120
+             WRITE ( mask_char,'(I2.2)')  mid
+             filename = 'DATA_MASK_' // mask_char // '_NETCDF' // coupling_char
+             av = 0
+          ELSE
+             mid = file_id - 140
+             WRITE ( mask_char,'(I2.2)')  mid
+             filename = 'DATA_MASK_' // mask_char // '_AV_NETCDF' // &
+                  coupling_char
+             av = 1
+          ENDIF
+!
+!--       Inquire, if there is a NetCDF file from a previuos run. This should
+!--       be opened for extension, if its dimensions and variables match the
+!--       actual run.
+          INQUIRE( FILE=filename, EXIST=netcdf_extend )
+
+          IF ( netcdf_extend )  THEN
+!
+!--          Open an existing NetCDF file for output 
+#if defined( __netcdf4 )
+             nc_stat = NF90_OPEN_PAR( filename, NF90_WRITE, comm2d, &
+                                      MPI_INFO_NULL, id_set_mask(mid,av) )
 #else
-
-       CASE ( 101:109, 111:113, 116 )
+             nc_stat = NF90_OPEN( filename, NF90_WRITE, id_set_mask(mid,av) )
+#endif
+             CALL handle_netcdf_error( 'check_open', 9998 )
+!
+!--          Read header information and set all ids. If there is a mismatch
+!--          between the previuos and the actual run, netcdf_extend is returned
+!--          as .FALSE.
+             CALL define_netcdf_header( 'ma', netcdf_extend, file_id )
+
+!
+!--          Remove the local file, if it can not be extended
+             IF ( .NOT. netcdf_extend )  THEN
+                nc_stat = NF90_CLOSE( id_set_mask(mid,av) )
+                CALL handle_netcdf_error( 'check_open', 9998 )
+                CALL local_system('rm ' // TRIM( filename ) )
+             ENDIF
+
+          ENDIF          
+
+          IF ( .NOT. netcdf_extend )  THEN
+!
+!--          Create a new NetCDF output file
+             SELECT CASE ( nc_format_mask(mid,av) )
+
+                CASE ( 1 )
+                   nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, &
+                        id_set_mask(mid,av) )
+
+                CASE ( 2 )
+#if defined( __netcdf_64bit )
+                   nc_stat = NF90_CREATE( filename, OR( NF90_NOCLOBBER, &
+                        NF90_64BIT_OFFSET ), id_set_mask(mid,av) )
+#else
+                   WRITE( message_string, * ) 'NetCDF: no 64-bit ', &
+                        'offset format allowed on this machine'
+                   CALL message( 'check_open', 'PA9998', 0, 1, 0, 6, 0 )
+                   nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, &
+                        id_set_mask(mid,av) )
+#endif
+
+                CASE ( 3 )
+#if defined( __netcdf4 )
+                   nc_stat = NF90_CREATE_PAR( filename, OR( NF90_NOCLOBBER, &
+                        NF90_NETCDF4 ), comm2d, MPI_INFO_NULL, &
+                        id_set_mask(mid,av) )
+#else
+                   WRITE( message_string, * ) 'NetCDF: no NetCDF 4 ', &
+                        'format allowed on this machine'
+                   CALL message( 'check_open', 'PA9998', 0, 1, 0, 6, 0 )
+                   nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, &
+                        id_set_mask(mid,av) )
+#endif
+
+                CASE ( 4 )
+#if defined( __netcdf4 )
+                   nc_stat = NF90_CREATE_PAR( filename, OR( NF90_NOCLOBBER, &
+                      NF90_CLASSIC_MODEL ), comm2d, &
+                      MPI_INFO_NULL, id_set_mask(mid,av) )
+#else
+                   WRITE( message_string, * ) 'NetCDF: no NetCDF 4 (Classic ', &
+                        'model) format allowed on this machine'
+                   CALL message( 'check_open', 'PA9998', 0, 1, 0, 6, 0 )
+                   nc_stat = NF90_CREATE( filename, NF90_NOCLOBBER, &
+                        id_set_mask(mid,av) )
+#endif
+
+                CASE DEFAULT
+                   WRITE( message_string, * ) 'illegal NetCDF file format: ', &
+                        'nc_format_mask(mid=',mid,',av=',av,')=', &
+                        nc_format_mask(mid,av)
+                   CALL message( 'check_open', 'PA9998', 2, 2, 0, 6, 0 )
+
+             END SELECT
+             CALL handle_netcdf_error( 'check_open', 9998 )
+!
+!--          Define the header
+             CALL define_netcdf_header( 'ma', netcdf_extend, file_id )
+
+          ENDIF
+
+
+#else
+
+       CASE ( 101:109, 111:113, 116, 121:160 )
 
 !
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 407)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 410)
@@ -5,4 +5,8 @@
 ! -----------------
 ! Enabled passive scalar/humidity wall fluxes for non-flat topography
+!
+! Branch revisions:
+! -----------------
+! Masked data output
 !
 ! Former revisions:
@@ -1477,4 +1481,7 @@
        IF ( dt_do3d           == 9999999.9 )  dt_do3d           = dt_data_output
        IF ( dt_data_output_av == 9999999.9 )  dt_data_output_av = dt_data_output
+       DO  mid = 1, 20
+          IF ( dt_domask(mid) == 9999999.9 )  dt_domask(mid)    = dt_data_output
+       ENDDO
     ENDIF
 
@@ -1495,4 +1502,8 @@
     IF ( skip_time_data_output_av == 9999999.9 ) &
                                 skip_time_data_output_av = skip_time_data_output
+    DO  mid = 1, 20
+       IF ( skip_time_domask(mid) == 9999999.9 ) &
+                                skip_time_domask(mid)    = skip_time_data_output
+    ENDDO
 
 !
@@ -2647,4 +2658,26 @@
 
 !
+!-- Check mask conditions
+    IF ( masks < 0 .OR. masks > max_masks )  THEN
+       WRITE( message_string, * )  'illegal value: masks must be >= 0 and ', &
+            '<= ', max_masks, ' (=max_masks)'
+       CALL message( 'check_parameters', 'PA9998', 1, 2, 0, 6, 0 )
+    ENDIF
+    IF ( masks > 0 )  THEN
+       mask_scale(1) = mask_scale_x
+       mask_scale(2) = mask_scale_y
+       mask_scale(3) = mask_scale_z
+       IF ( ANY( mask_scale <= 0.0 ) )  THEN
+          WRITE( message_string, * )  &
+               'illegal value: mask_scale_x, mask_scale_y and mask_scale_z', &
+               'must be > 0.0'
+          CALL message( 'check_parameters', 'PA9998', 1, 2, 0, 6, 0 )
+       ENDIF
+!
+!--    Generate masks for masked data output
+       CALL init_masks
+    ENDIF
+
+!
 !-- Check netcdf precison
     ldum = .FALSE.
Index: palm/trunk/SOURCE/close_file.f90
===================================================================
--- palm/trunk/SOURCE/close_file.f90	(revision 407)
+++ palm/trunk/SOURCE/close_file.f90	(revision 410)
@@ -5,4 +5,8 @@
 ! -----------------
 ! 
+!
+! Branch revisions:
+! -----------------
+! masked data output
 !
 ! Former revisions:
@@ -59,5 +63,5 @@
     CHARACTER (LEN=80)  ::  rtext, title, utext = '', xtext = '', ytext = ''
 
-    INTEGER ::  anzzeile, cranz, cross_count, cross_numbers, dimx, dimy, &
+    INTEGER ::  av, anzzeile, cranz, cross_count, cross_numbers, dimx, dimy, &
                 fid, file_id, j, k, legpos = 1, planz, timodex = 1
     INTEGER, DIMENSION(100) ::  klist, lstyle, cucol
@@ -94,5 +98,5 @@
 !
 !-- Close all open unit numbers
-    DO  fid = 1, 116
+    DO  fid = 1, 160
 
        IF ( openfile(fid)%opened .OR. openfile(fid)%opened_before )  THEN
@@ -493,4 +497,34 @@
                    nc_stat = NF90_CLOSE( id_set_3d(1) )
                    CALL handle_netcdf_error( 'close_file', 353 )
+                ENDIF
+
+             CASE ( 121:160 )
+	     
+	        IF ( format_parallel_io ) THEN
+!
+!--                decompose fid into mid and av
+                   IF ( fid <= 140 )  THEN
+                      mid = fid - 120
+                      av = 0
+                   ELSE
+                      mid = fid - 140
+                      av = 1
+                   ENDIF
+                   nc_stat = NF90_CLOSE( id_set_mask(mid,av) )
+                   CALL handle_netcdf_error( 'close_file', 9998 )
+		
+		ELSEIF ( myid == 0  .AND.  netcdf_output )  THEN
+!
+!--                decompose fid into mid and av
+                   IF ( fid <= 140 )  THEN
+                      mid = fid - 120
+                      av = 0
+                   ELSE
+                      mid = fid - 140
+                      av = 1
+                   ENDIF
+                   nc_stat = NF90_CLOSE( id_set_mask(mid,av) )
+                   CALL handle_netcdf_error( 'close_file', 9998 )
+		   
                 ENDIF
 
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 410)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 410)
@@ -0,0 +1,452 @@
+ SUBROUTINE data_output_mask( av )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! Bugfix: to_be_resorted => s_av for time-averaged scalars
+! 
+!
+! Former revisions:
+! -----------------
+! $Id$
+!
+!
+! Description:
+! ------------
+! Masked data output in NetCDF format for current mask (current value of mid).
+!------------------------------------------------------------------------------!
+
+#if defined( __netcdf )
+    USE arrays_3d
+    USE averaging
+    USE cloud_parameters
+    USE control_parameters
+    USE cpulog
+    USE grid_variables
+    USE indices
+    USE interfaces
+    USE netcdf
+    USE netcdf_control
+    USE particle_attributes
+    USE pegrid
+
+    IMPLICIT NONE
+
+    INTEGER ::  av, ngp, file_id, i, if, is, j, k, l, n, psi, s, sender, &
+                ind(6)
+    LOGICAL ::  found, resorted
+    REAL    ::  mean_r, s_r3, s_r4
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  local_pf
+#if defined( __parallel )
+    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  total_pf
+#endif
+    REAL, DIMENSION(:,:,:), POINTER ::  to_be_resorted
+
+!
+!-- Return, if nothing to output
+    IF ( domask_no(mid,av) == 0 )  RETURN
+
+    CALL cpu_log (log_point(49),'data_output_mask','start')
+
+!!
+!-- Open output file.
+    IF ( format_parallel_io .AND. netcdf_output )  THEN
+       CALL check_open( 120+mid+av*max_masks )
+    ELSEIF (myid == 0  .AND.  netcdf_output ) THEN
+       CALL check_open( 120+mid+av*max_masks )
+    ENDIF 
+
+!
+!-- Allocate total and local output arrays.
+#if defined( __parallel )
+    IF ( myid == 0 )  THEN
+       ALLOCATE( total_pf(mask_size(mid,1),mask_size(mid,2),mask_size(mid,3)) )
+    ENDIF
+#endif
+    ALLOCATE( local_pf(mask_size_l(mid,1),mask_size_l(mid,2), &
+                       mask_size_l(mid,3)) )
+
+!
+!-- Update the NetCDF time axis.
+    domask_time_count(mid,av) = domask_time_count(mid,av) + 1
+    IF ( format_parallel_io .AND. netcdf_output )  THEN
+       nc_stat = NF90_PUT_VAR( id_set_mask(mid,av), id_var_time_mask(mid,av), &
+                               (/ simulated_time /),                          &
+                               start = (/ domask_time_count(mid,av) /),       &
+                               count = (/ 1 /) )
+       CALL handle_netcdf_error( 'data_output_mask', 9998 )
+    ELSEIF ( myid == 0  .AND.  netcdf_output )  THEN
+       nc_stat = NF90_PUT_VAR( id_set_mask(mid,av), id_var_time_mask(mid,av), &
+                               (/ simulated_time /),                          &
+                               start = (/ domask_time_count(mid,av) /),       &
+                               count = (/ 1 /) )
+       CALL handle_netcdf_error( 'data_output_mask', 9998 )
+    ENDIF
+
+!
+!-- Loop over all variables to be written.
+    if = 1
+
+    DO  WHILE ( domask(mid,av,if)(1:1) /= ' ' )
+!
+!--    Reallocate local_pf on PE 0 since its shape changes during MPI exchange
+       IF ( .NOT. format_parallel_io .AND. myid == 0 .AND. if > 1 )  THEN
+          DEALLOCATE( local_pf )
+          ALLOCATE( local_pf(mask_size_l(mid,1),mask_size_l(mid,2), &
+                             mask_size_l(mid,3)) )
+       ENDIF
+!
+!--    Store the variable chosen.
+       resorted = .FALSE.
+       SELECT CASE ( TRIM( domask(mid,av,if) ) )
+
+          CASE ( 'e' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => e
+             ELSE
+                to_be_resorted => e_av
+             ENDIF
+
+          CASE ( 'p' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => p
+             ELSE
+                to_be_resorted => p_av
+             ENDIF
+
+          CASE ( 'pc' )  ! particle concentration (requires ghostpoint exchange)
+             IF ( av == 0 )  THEN
+                tend = prt_count
+                CALL exchange_horiz( tend )
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) =  tend(mask_k(mid,k), &
+                                   mask_j(mid,j),mask_i(mid,i))
+                      ENDDO
+                   ENDDO
+                ENDDO
+                resorted = .TRUE.
+             ELSE
+                CALL exchange_horiz( pc_av )
+                to_be_resorted => pc_av
+             ENDIF
+
+          CASE ( 'pr' )  ! mean particle radius
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         psi = prt_start_index(k,j,i)
+                         s_r3 = 0.0
+                         s_r4 = 0.0
+                         DO  n = psi, psi+prt_count(k,j,i)-1
+                            s_r3 = s_r3 + particles(n)%radius**3
+                            s_r4 = s_r4 + particles(n)%radius**4
+                         ENDDO
+                         IF ( s_r3 /= 0.0 )  THEN
+                            mean_r = s_r4 / s_r3
+                         ELSE
+                            mean_r = 0.0
+                         ENDIF
+                         tend(k,j,i) = mean_r
+                      ENDDO
+                   ENDDO
+                ENDDO
+                CALL exchange_horiz( tend )
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) =  tend(mask_k(mid,k), &
+                                   mask_j(mid,j),mask_i(mid,i))
+                      ENDDO
+                   ENDDO
+                ENDDO
+                resorted = .TRUE.
+             ELSE
+                CALL exchange_horiz( pr_av )
+                to_be_resorted => pr_av
+             ENDIF
+
+          CASE ( 'pt' )
+             IF ( av == 0 )  THEN
+                IF ( .NOT. cloud_physics ) THEN
+                   to_be_resorted => pt
+                ELSE
+                   DO  i = 1, mask_size_l(mid,1)
+                      DO  j = 1, mask_size_l(mid,2)
+                         DO  k = 1, mask_size_l(mid,3)
+                            local_pf(i,j,k) =  &
+                                 pt(mask_k(mid,k),mask_j(mid,j),mask_i(mid,i)) &
+                                 + l_d_cp * pt_d_t(mask_k(mid,k)) * &
+                                   ql(mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
+                         ENDDO
+                      ENDDO
+                   ENDDO
+                   resorted = .TRUE.
+                ENDIF
+             ELSE
+                to_be_resorted => pt_av
+             ENDIF
+
+          CASE ( 'q' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => q
+             ELSE
+                to_be_resorted => q_av
+             ENDIF
+             
+          CASE ( 'ql' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => ql
+             ELSE
+                to_be_resorted => ql_av
+             ENDIF
+
+          CASE ( 'ql_c' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => ql_c
+             ELSE
+                to_be_resorted => ql_c_av
+             ENDIF
+
+          CASE ( 'ql_v' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => ql_v
+             ELSE
+                to_be_resorted => ql_v_av
+             ENDIF
+
+          CASE ( 'ql_vp' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => ql_vp
+             ELSE
+                to_be_resorted => ql_vp_av
+             ENDIF
+
+          CASE ( 'qv' )
+             IF ( av == 0 )  THEN
+                DO  i = 1, mask_size_l(mid,1)
+                   DO  j = 1, mask_size_l(mid,2)
+                      DO  k = 1, mask_size_l(mid,3)
+                         local_pf(i,j,k) =  &
+                              q(mask_k(mid,k),mask_j(mid,j),mask_i(mid,i)) -  &
+                              ql(mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
+                      ENDDO
+                   ENDDO
+                ENDDO
+                resorted = .TRUE.
+             ELSE
+                to_be_resorted => qv_av
+             ENDIF
+
+          CASE ( 'rho' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => rho
+             ELSE
+                to_be_resorted => rho_av
+             ENDIF
+             
+          CASE ( 's' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => q
+             ELSE
+                to_be_resorted => s_av
+             ENDIF
+             
+          CASE ( 'sa' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => sa
+             ELSE
+                to_be_resorted => sa_av
+             ENDIF
+             
+          CASE ( 'u' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => u
+             ELSE
+                to_be_resorted => u_av
+             ENDIF
+
+          CASE ( 'v' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => v
+             ELSE
+                to_be_resorted => v_av
+             ENDIF
+
+          CASE ( 'vpt' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => vpt
+             ELSE
+                to_be_resorted => vpt_av
+             ENDIF
+
+          CASE ( 'w' )
+             IF ( av == 0 )  THEN
+                to_be_resorted => w
+             ELSE
+                to_be_resorted => w_av
+             ENDIF
+
+          CASE DEFAULT
+!
+!--          User defined quantity
+             CALL user_data_output_mask(av, domask(mid,av,if), found, local_pf )
+             resorted = .TRUE.
+
+             IF ( .NOT. found )  THEN
+                WRITE ( message_string, * ) 'no output available for: ', &
+                                            TRIM( domask(mid,av,if) )
+                CALL message( 'data_output_mask', 'PA9998', 0, 0, 0, 6, 0 )
+             ENDIF
+
+       END SELECT
+
+!
+!--    Resort the array to be output, if not done above
+       IF ( .NOT. resorted )  THEN
+          DO  i = 1, mask_size_l(mid,1)
+             DO  j = 1, mask_size_l(mid,2)
+                DO  k = 1, mask_size_l(mid,3)
+                   local_pf(i,j,k) =  to_be_resorted(mask_k(mid,k), &
+                                      mask_j(mid,j),mask_i(mid,i))
+                ENDDO
+             ENDDO
+          ENDDO
+       ENDIF
+
+!
+!--    I/O block. I/O methods are implemented
+!--    (1) for parallel execution
+!--     a. with NetCDF 4 parallel I/O-enabled library
+!--     b. with NetCDF 3 library
+!--    (2) for serial execution.
+!--    The choice of method depends on the correct setting of preprocessor
+!--    directives __parallel and __netcdf4 as well as on the parameter 
+!--    nc_format_mask(mid,av).
+#if defined( __parallel )
+#if defined( __netcdf4 )
+       IF ( nc_format_mask(mid,av) == 3 .OR. nc_format_mask(mid,av) == 4 )  THEN
+!
+!--       (1) a. Parallel I/O using NetCDF 4 (not yet tested)
+          nc_stat = NF90_PUT_VAR( id_set_mask(mid,av),  &
+               id_var_domask(mid,av,if),  &
+               local_pf,  &
+               start = (/ mask_start_l(mid,1), mask_start_l(mid,2),  &
+                          mask_start_l(mid,3), domask_time_count(mid,av) /),  &
+               count = (/ mask_size_l(mid,1), mask_size_l(mid,2),  &
+                          mask_size_l(mid,3), 1 /) )
+          CALL handle_netcdf_error( 'data_output_mask', 9998 )
+       ELSE
+#endif
+!
+!--       (1) b. Conventional I/O only through PE0
+!--       PE0 receives partial arrays from all processors of the respective mask
+!--       and outputs them. Here a barrier has to be set, because otherwise 
+!--       "-MPI- FATAL: Remote protocol queue full" may occur.
+          CALL MPI_BARRIER( comm2d, ierr )
+
+          ngp = mask_size_l(mid,1) * mask_size_l(mid,2) * mask_size_l(mid,3)
+          IF ( myid == 0 )  THEN
+!
+!--          Local array can be relocated directly.
+             total_pf( &
+               mask_start_l(mid,1):mask_start_l(mid,1)+mask_size_l(mid,1)-1, &
+               mask_start_l(mid,2):mask_start_l(mid,2)+mask_size_l(mid,2)-1, &
+               mask_start_l(mid,3):mask_start_l(mid,3)+mask_size_l(mid,3)-1 ) &
+               = local_pf
+!
+!--          Receive data from all other PEs.
+             DO  n = 1, numprocs-1
+!
+!--             Receive index limits first, then array.
+!--             Index limits are received in arbitrary order from the PEs.
+                CALL MPI_RECV( ind(1), 6, MPI_INTEGER, MPI_ANY_SOURCE, 0,  &
+                     comm2d, status, ierr )
+!
+!--             Not all PEs have data for the mask
+                IF ( ind(1) /= -9999 )  THEN
+                   ngp = ( ind(2)-ind(1)+1 ) * (ind(4)-ind(3)+1 ) *  &
+                         ( ind(6)-ind(5)+1 )
+                   sender = status(MPI_SOURCE)
+                   DEALLOCATE( local_pf )
+                   ALLOCATE(local_pf(ind(1):ind(2),ind(3):ind(4),ind(5):ind(6)))
+                   CALL MPI_RECV( local_pf(ind(1),ind(3),ind(5)), ngp,  &
+                        MPI_REAL, sender, 1, comm2d, status, ierr )
+                   total_pf(ind(1):ind(2),ind(3):ind(4),ind(5):ind(6)) &
+                        = local_pf
+                ENDIF
+             ENDDO
+
+             nc_stat = NF90_PUT_VAR( id_set_mask(mid,av),  &
+                  id_var_domask(mid,av,if), total_pf, &
+                  start = (/ 1, 1, 1, domask_time_count(mid,av) /), &
+                  count = (/ mask_size(mid,1), mask_size(mid,2), &
+                             mask_size(mid,3), 1 /) )
+             CALL handle_netcdf_error( 'data_output_mask', 9998 )
+
+          ELSE
+!
+!--          If at least part of the mask resides on the PE, send the index
+!--          limits for the target array, otherwise send -9999 to PE0.
+             IF ( mask_size_l(mid,1) > 0 .AND.  mask_size_l(mid,2) > 0 .AND. &
+                  mask_size_l(mid,3) > 0  ) &
+                  THEN
+                ind(1) = mask_start_l(mid,1)
+                ind(2) = mask_start_l(mid,1) + mask_size_l(mid,1) - 1
+                ind(3) = mask_start_l(mid,2)
+                ind(4) = mask_start_l(mid,2) + mask_size_l(mid,2) - 1
+                ind(5) = mask_start_l(mid,3)
+                ind(6) = mask_start_l(mid,3) + mask_size_l(mid,3) - 1
+             ELSE
+                ind(1) = -9999; ind(2) = -9999
+                ind(3) = -9999; ind(4) = -9999
+                ind(5) = -9999; ind(6) = -9999
+             ENDIF
+             CALL MPI_SEND( ind(1), 6, MPI_INTEGER, 0, 0, comm2d, ierr )
+!
+!--          If applicable, send data to PE0.
+             IF ( ind(1) /= -9999 )  THEN
+                CALL MPI_SEND( local_pf(1,1,1), ngp, MPI_REAL, 0, 1, comm2d, &
+                     ierr )
+             ENDIF
+          ENDIF
+!
+!--       A barrier has to be set, because otherwise some PEs may proceed too
+!--       fast so that PE0 may receive wrong data on tag 0.
+          CALL MPI_BARRIER( comm2d, ierr )
+#if defined( __netcdf4 )
+       ENDIF
+#endif
+#else
+!
+!--    (2) For serial execution of PALM, the single processor (PE0) holds all
+!--    data and writes them directly to file.
+       nc_stat = NF90_PUT_VAR( id_set_mask(mid,av),  &
+            id_var_domask(mid,av,if),       &
+            local_pf(mask_size_l(mid,1),mask_size_l(mid,2), &
+                     mask_size_l(mid,3)),&
+            start = (/ 1, 1, 1, domask_time_count(mid,av) /), &
+            count = (/ mask_size_l(mid,1), mask_size_l(mid,2), &
+                       mask_size_l(mid,3), 1 /) )
+       CALL handle_netcdf_error( 'data_output_mask', 9998 )
+#endif
+
+       if = if + 1
+    ENDDO
+
+!
+!-- Deallocate temporary arrays.
+    DEALLOCATE( local_pf )
+#if defined( __parallel )
+    IF ( myid == 0 )  THEN
+       DEALLOCATE( total_pf )
+    ENDIF
+#endif
+
+
+    CALL cpu_log (log_point(49),'data_output_mask','stop','nobarrier')
+#endif
+
+ END SUBROUTINE data_output_mask
